<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 1.8: Arguments -- Call by Value</title>
<link href="sx4k.html" rev=precedes>
<link href="sx4m.html" rel=precedes>
<link href="sx4.html" rev=subdocument>
</head>
<body>
<H2>section 1.8: Arguments -- Call by Value</H2>

page 27
<p>If,
on the other hand,
you are <em>not</em> used to other languages such as Fortran,
these call-by-value semantics may not be surprising
(any more than anything else in C which is new to you).
</p><p>Even though you <em>can</em> modify a parameter in a function
(i.e. treat it as a ``conveniently initialized local variable''),
you certainly don't have to,
especially if
(as is often the case)
you'll need an unmodified copy of the parameter later in the function.
</p><p>page 28
</p><p>Don't worry too much about the exception mentioned for 
arrays--there
are a number of exceptions for arrays, and we'll have much more
to say about them later.
But be aware that we are deliberately glossing over a few details here,
and they are details which will be come important later on.
(In particular, the statement on page 27 that ``the called 
function cannot directly alter a variable in the calling 
function'' may not seem to be true for arrays, and this is 
what the authors mean when they say that ``The story is 
different''.
We'll be seeing several functions which return 
things--usually strings--to
their callers by writing into caller-supplied arrays.
In chapter 5 we'll learn how this is possible.
If this discrepancy wouldn't have bothered you now,
pretend I didn't mention it.)
</p><hr>
<p>
Read sequentially:
<a href="sx4k.html" rev=precedes>prev</a>
<a href="sx4m.html" rel=precedes>next</a>
<a href="sx4.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
